ru.bitel.bgbilling.modules.softline.common.service

## Interface ProductService

-     public interface ProductService

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `deleteProduct(Product product)` Удаление продукта из биллинга и всей его истории.
    `void` | `deleteProductCategory(ProductCategory productCategory)`
    `ProductCategory` | `getCategoryOfProduct(int productCategoryId)` Получение категории продуктов по его id
    `SearchResult<ProductCategory>` | `getProductCategories(Page page)`
    `byte[]` | `getProductPicture(int id, TypeProduct type)`
    `void` | `getProductPicture0(int id, javax.xml.ws.Holder<javax.activation.DataHandler> fileData, TypeProduct type)` Получение изображения продукта для отображения в ЛК
    `SearchResult<Product>` | `getProducts(Page page)`
    `java.util.List<Product>` | `getProductsOfCategory(int productCategoryId)`
    `void` | `setProductPicture(int id, byte[] picture, TypeProduct type)`
    `void` | `updateProduct(Product product)`
    `void` | `updateProductCategory(ProductCategory productCategory)`

- - ### Method Detail

    - #### getProducts

          SearchResult<Product> getProducts(Page page)
                                     throws ru.bitel.bgbilling.common.BGException

      Returns:
        получение списка продуктов
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### updateProduct

          void updateProduct(Product product)
                      throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### deleteProduct

          void deleteProduct(Product product)
                      throws ru.bitel.bgbilling.common.BGException

      Удаление продукта из биллинга и всей его истории.
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getProductCategories

          SearchResult<ProductCategory> getProductCategories(Page page)
                                                      throws ru.bitel.bgbilling.common.BGException

      Returns:
        список всех заведённых категорий продуктов
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### updateProductCategory

          void updateProductCategory(ProductCategory productCategory)
                              throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### deleteProductCategory

          void deleteProductCategory(ProductCategory productCategory)
                              throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getCategoryOfProduct

          ProductCategory getCategoryOfProduct(int productCategoryId)
                                        throws ru.bitel.bgbilling.common.BGException

      Получение категории продуктов по его id
      Parameters:
        `productCategoryId` - - id категории продуктов
      Returns:
        категория продуктов SoftLine
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getProductsOfCategory

          java.util.List<Product> getProductsOfCategory(int productCategoryId)
                                                 throws ru.bitel.bgbilling.common.BGException

      Parameters:
        `productCategoryId` - id категории
      Returns:
        список продуктов SoftLine для определённой категории
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### setProductPicture

          void setProductPicture(int id,
                                 byte[] picture,
                                 TypeProduct type)
                          throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getProductPicture

          byte[] getProductPicture(int id,
                                   TypeProduct type)
                            throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getProductPicture0

          void getProductPicture0(int id,
                                  javax.xml.ws.Holder<javax.activation.DataHandler> fileData,
                                  TypeProduct type)
                           throws ru.bitel.bgbilling.common.BGException

      Получение изображения продукта для отображения в ЛК
      Parameters:
        `id` - id продукта или категории для которого получается изображение
        `fileData` - holder для результата
      Throws:
        `ru.bitel.bgbilling.common.BGException`